-------------------------------------------------------------------------------
-- test bench for stack3.vhd
--
-- Author(s):     Pinhas Krengel
-- Created:       oct 2009
-- Last Modified: oct 2009
-- 
-- Simple test bench to see general opertaion with free vhdl simulator.
--
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;

use STD.textio.all;
use IEEE.STD_LOGIC_TEXTIO.all;

--random
USE ieee.math_real.ALL;   -- for UNIFORM, TRUNC functions
USE ieee.numeric_std.ALL; -- for TO_UNSIGNED function

--counter plus opertor
use IEEE.STD_LOGIC_UNSIGNED."+";

entity count_rand_TSB is
end count_rand_TSB;


architecture BHV of count_rand_TSB is
  signal rstn     : STD_LOGIC := '0';
  signal clk      : STD_LOGIC := '0';
  signal cnt      : std_logic_vector(3 downto 0);
begin
  rstn <= '1'     after 50 ns;
  clk  <= not clk after  20 ns;

  process (rstn, clk) 

    -- Seed values for random generator
    VARIABLE seed1, seed2: positive; --default init value 1
    VARIABLE rand: real;             -- Random real-number value in range 0 to 1.0
    VARIABLE int_rand: integer;      -- Random integer 
  BEGIN

	seed1 := 2;
	seed2 := 4;
    UNIFORM(seed1, seed2, rand); -- generate random number
	-- rescale to 0..4096, find integer part
  --int_rand := INTEGER(TRUNC(rand*4096.0)); 


    if rstn = '0' then
	  cnt <= "0000";
	--cnt <= std_logic_vector(to_unsigned(int_rand, 4));
	elsif clk'event and clk = '1' then
    --int_rand := INTEGER(TRUNC(rand*16.0)); 
      int_rand := INTEGER(TRUNC(rand*4.0)); 
	  cnt <= cnt + std_logic_vector(to_unsigned(int_rand, 4));
	--cnt <= cnt + "0001";
	end if;
  end process;
end BHV;
